/*
 * 1.1 code.
 */

import java.awt.*;
import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.event.*;
import java.text.*;
import java.awt.Toolkit;

/* 
 * This applet displays a looping icon.  It prevents
 * flashing by double buffering.  Wait that the images are 
 * loaded before starting the animation
 * Author Paolo Cignoni (starting form a Sun java Tutorial example)
 */

public class ALoopingIcon extends Applet implements Runnable, MouseListener {
    int frameNumber = -1;
    int delay;
    Thread animatorThread;
    boolean frozen = false;
	MediaTracker tracker;
    Dimension offDimension;
    Image offImage;
    Graphics offGraphics;

    Image[] images;
	AudioClip Drip,Drop;
    public void init() {
        String str;
        int fps = 10;
        tracker = new MediaTracker(this);
		addMouseListener(this);
		
        //How many milliseconds between frames?
        str = getParameter("fps");
        try {
            if (str != null) {
                fps = Integer.parseInt(str);
            }
        } catch (Exception e) {}
        delay = (fps > 0) ? (1000 / fps) : 100;

		Drip=getAudioClip(getCodeBase(),"drip.au");
		Drop=getAudioClip(getCodeBase(),"drop.au");
        //Load all the images.
        images = new Image[42];
		DecimalFormat iFormatter = new DecimalFormat("0000");
        for (int i = 0; i <= 20; i++) {
            images[i] = getImage(getCodeBase(),
                          "aloopingicon"+iFormatter.format(i*5)+".jpg");
			tracker.addImage(images[i], 1);
		}
		int c=21;				  
		for (int i = 20; i >= 0; i--) {
			images[c++]= images[i];						  
        }
    }
	public void stop() {
	animatorThread =null;
	}
	
    public void start() {
        if (frozen) {
            //Do nothing.  The user has requested that we
            //stop changing the image.
        } else {
            //Start animating!
            if (animatorThread == null) {
                animatorThread = new Thread(this);
            }
            animatorThread.start();
        }
    }

    public void mousePressed(MouseEvent event) {	
	    Toolkit.getDefaultToolkit().beep();
        if (frozen) {
            frozen = false;
            start();
        } else {
            frozen = true;
			animatorThread = null;
        }
	}

    public void run() {
        //Just to be nice, lower this thread's priority
        //so it can't interfere with other processing going on.
        Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
 
        //Remember the starting time.
        long startTime = System.currentTimeMillis();

        //This is the animation loop.
        while (Thread.currentThread() == animatorThread) {
		//while (!frozen) {
            //Advance the animation frame.
            frameNumber++;

            //Display it.
            repaint();

            //Delay depending on how far we are behind.
            try {
                startTime += delay;
                Thread.sleep(Math.max(0, 
                                      startTime-System.currentTimeMillis()));
            } catch (InterruptedException e) {
                break;
            }
        }
    }

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        Dimension d = getSize();
		if (! tracker.checkAll(true) ) {
			g.drawString("Please wait," , 0, 30);
			g.drawString("Loading images..." , 0, 50);
			return;
			}
		
        //Create the offscreen graphics context, if no good one exists.
        if ( (offGraphics == null)
          || (d.width != offDimension.width)
          || (d.height != offDimension.height) ) {
            offDimension = d;
            offImage = createImage(d.width, d.height);
            offGraphics = offImage.getGraphics();
        }

        //Erase the previous image.
        offGraphics.setColor(getBackground());
        offGraphics.fillRect(0, 0, d.width, d.height);
        offGraphics.setColor(Color.black);

        //Paint the frame into the image.
        offGraphics.drawImage(images[frameNumber % 42], 0, 0, this);
		if((frameNumber % 42)== 0) Drop.play();
		if((frameNumber % 42)== 21) Drip.play();
		
        //Paint the image onto the screen.
        g.drawImage(offImage, 0, 0, this);
    }

	public void mouseClicked(MouseEvent event) {}
    public void mouseReleased(MouseEvent event) {}
    public void mouseEntered(MouseEvent event) {}
    public void mouseExited(MouseEvent event) {}


}
